<?php
	echo "<style> pre {color:yellow; background:darkblue;} </style>";		
	
	// Etiquetas simples, de tipo: [etiqueta].......[/etiqueta]
	function parse_single($singlelabel, $format, $post)
	{
		$label1 = "[".$singlelabel."]";
		$label2 = "[/".$singlelabel."]";
		while (!(stripos($post, $label1)===false))
		{
			$pos1 = stripos($post, $label1);
			$pos2 = striposfrom($post, $label2, $pos1);
			if ($pos2===false) break;
			$left = str_left($post, $pos1);
			$middle = str_mid($post, $pos1+strlen($label1), $pos2-1);
			$right = str_mid($post, $pos2+strlen($label2), strlen($post));
			$post = str_ireplace("%label%", $singlelabel, $format);
			$post = str_ireplace("%left%", $left, $post);
			$post = str_ireplace("%middle%", $middle, $post);
			$post = str_ireplace("%right%", $right, $post);						
		}
		return $post;
	}
	
	
	// Etiquetas complejas, de tipo: [etiqueta=valor].......[/etiqueta]
	function parse_complex($complexlabel, $format, $post)
	{
		$label1 = "[".$complexlabel."=";
		$label2 = "[/".$complexlabel."]";
		while (!(stripos($post, $label1)===false) )
		{
			$pos1 = stripos($post, $label1);			
			$pos2 = striposfrom($post, "]", $pos1);
			if ($pos2===false) break;
			$pos3 = striposfrom($post, $label2, $pos2);
			if ($pos3===false) break;
			
			$left = str_left($post, $pos1);
			$middle = str_mid($post, $pos2+1, $pos3-1);
			$right = str_mid($post, $pos3+strlen($label2), strlen($post));
			$param = str_mid($post, $pos1+strlen($label1), $pos2-1);
			$post = str_ireplace("%label%", $complexlabel, $format);
			$post = str_ireplace("%left%", $left, $post);
			$post = str_ireplace("%middle%", $middle, $post);
			$post = str_ireplace("%right%", $right, $post);			
			$post = str_ireplace("%param%", $param, $post);						
		}		
		return $post;
	}
	
	
	function parse_post($post, $html_on, $bbcodes_on)
	{	
		if (!$html_on) $post=htmlspecialchars($post);
	
		if ($bbcodes_on)
		{
			$bbcodes = parse_ini_file("bbcodes.dat", true);	
		
			// Code...
			while (!(stripos($post, "[code]")===false))
			{
				$pos1 = stripos($post, "[code]");
				$pos2 = striposfrom($post, "[/code]", $pos1);
				if ($pos2===false) break;
								
				$aux = str_mid($post, $pos1+6, $pos2-1);
				if (!html_on) $aux = htmlspecialchars($aux);
				$aux = str_ireplace("[", chr(7), $aux);
				$aux = str_ireplace("]", chr(8), $aux);
				$post = str_left($post, $pos1)."<p><b><i>Cdigo:</i><pre>".$aux."</b></pre></p>".str_mid($post, $pos2+7, strlen($post)-1);
			}
			
			// Google...
			while (!(stripos($post, "[google]")===false))
			{
				$pos1 = stripos($post, "[google]");
				$pos2 = striposfrom($post, "[/google]", $pos1);
				if ($pos2===false) break;
								
				$aux = str_mid($post, $pos1+8, $pos2-1);
				if (!html_on) $aux = htmlspecialchars($aux);
				$aux = str_ireplace("[", chr(7), $aux);
				$aux = str_ireplace("]", chr(8), $aux);
				$post = str_left($post, $pos1)."<p><b><i>Cdigo:</i><pre>".$aux."</b></pre></p>".str_mid($post, $pos2+9, strlen($post)-1);
			}
			
			while (list($key, $val) = each($bbcodes))
			{
				while (list($k, $v) = each($val))
				{
					switch(strtolower($key))
					{
						case "single": 
						{
							$post = parse_single($k, $v, $post);
							break;
						}
						case "complex": 
						{
							$post = parse_complex($k, $v, $post);
							break;	
						}
					}
				}
			}
		}
		
		$post = str_ireplace(chr(7), "[", $post);
		$post = str_ireplace(chr(8), "]", $post);		
		$post = str_replace(chr(13).chr(10), "<br>", $post);
		return $post;
	}
?>
	